#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "s2plot.h"

int main(int argc, char *argv[])
{
   XYZ vertex[3];				/* 3 vertices */
   XYZ normal[3];				/* 3 vertices */
   float alpha[3];				/* 3 vertices */
   COLOUR col[3];				/* 3 vertices */
   char trans = 't';				/* Transparency type */
   int i;

   srand48((long)time(NULL));			/* Seed random numbers */
   s2opend("/?",argc, argv);			/* Open the display */
   s2swin(-1.,1., -1.,1., -1.,1.);		/* Set the window coordinates */
   s2box("BCDET",0,0,"BCDET",0,0,"BCDET",0,0);	/* Draw coordinate box */

   for (i=0;i<3;i++) {
      vertex[i].x = drand48()*2.0 - 1.0;	/* Random corners to facet */
      vertex[i].y = drand48()*2.0 - 1.0;
      vertex[i].z = drand48()*2.0 - 1.0;
      normal[i].x = drand48()*2.0 - 1.0;	/* Random normal for facet */
      normal[i].y = drand48()*2.0 - 1.0;
      normal[i].z = drand48()*2.0 - 1.0;
      col[i].r = drand48();			/* Random colour for vertex */
      col[i].g = drand48();
      col[i].b = drand48();
   }
   alpha[0] = 0.0;				/* Set alpha channels for each */
   alpha[1] = 0.5;				/*   vertex */
   alpha[2] = 1.0;
   ns2vf3nca(vertex, normal, col, trans, alpha);
			/* Draw polygon with defined normals, vertex colours */
			/* and vertex transparencies */

   s2show(1);					/* Open the s2plot window */
   
   return 1;
}
