#include <stdio.h>
#include <stdlib.h>
#include "s2plot.h"

void cb(double *t, int *kc)
{
   int pt = ss2qpt();			/* Query current projection type */

   char string[32];			
   sprintf(string,"Projection type = %d",pt);	/* Write to string */
   s2textxy(0,0,0,string);		/* Display text */

   int spt = (*kc % 2);			/* Generate new projection type */
   ss2spt(spt);				/* Set the new projection type */

   switch (*kc % 2) {
      case 0 : s2lab("","","","Perspective"); break;
      case 1 : s2lab("","","","Orthographic"); break;
   }
   
}

int main(int argc, char *argv[])
{
   fprintf(stderr,"Press the <spacebar> to change projection type");

   s2opend("/s2mono", argc, argv);             /* Open in mono mode */
   s2swin(-1.,1., -1.,1., -1.,1.);              /* Set the window coordinates */
   s2box("BCDET",0,0,"BCDET",0,0,"BCDET",0,0);  /* Draw coordinate box */
   
   cs2scb(cb);					/* Install dynamic callback */
   s2show(1);                                   /* Open the s2plot window */

   return 1;
}
